package net.wanji.common.utils.tool;

import lombok.extern.slf4j.Slf4j;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;

/**
 * @author duanruiming
 * @date 2023/03/21 10:32
 */
@Slf4j
public class SocketUtil {

    /**
     * 通过socket连接测试服务端口是否正常
     *
     * @param ip
     * @param port
     * @param timeout
     * @return
     * @throws Exception
     */
    public static boolean telnet(String ip, int port, int timeout) throws Exception{
        Socket socket = new Socket();
        boolean status = false;
        try {
            socket.connect(new InetSocketAddress(ip, port), timeout);
            status = socket.isConnected();
        } catch (IOException e) {
            log.error("当前IP:{}, port:{}， 连接失败，服务异常！", ip, port);
        } finally {
            try {
                socket.close();
            } catch (IOException e) {
                log.error("当前IP:{}, port:{}， 关闭连接失败，服务异常！", ip, port);
            }
        }

        return status;
    }
}
